src/main/java/model/Local.java
package model;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.OneToMany;

import org.hibernate.annotations.Cascade;

@Entity
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
public abstract class Local {
	
	@Id @GeneratedValue(strategy=GenerationType.SEQUENCE)
	private long id;
	
	private String nome;
	
	private String bairro;
	private String rua;
	private String numero;
	private String cep;
	
	@OneToMany(cascade=CascadeType.ALL)
	private List<HorarioReserva> horariosAlugados = new ArrayList<HorarioReserva>();
	
	public String getBairro() {
		return bairro;
	}
	public void setBairro(String bairro) {
		this.bairro = bairro;
	}
	public String getRua() {
		return rua;
	}
	public void setRua(String rua) {
		this.rua = rua;
	}
	public String getNumero() {
		return numero;
	}
	public void setNumero(String numero) {
		this.numero = numero;
	}
	public String getCep() {
		return cep;
	}
	public void setCep(String cep) {
		this.cep = cep;
	}

	public long getId() {
		return id;
	}
	public void setId(long id) {
		this.id = id;
	}

	public List<HorarioReserva> getHorariosAlugados() {
		return horariosAlugados;
	}
	public void setHorariosAlugados(List<HorarioReserva> horariosAlugados) {
		this.horariosAlugados = horariosAlugados;
	}
	public abstract double getValorAluguel();
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getNome() {
		return nome;
	}
	
	
}

src/main/java/model/LocalPrivado.java
package model;

import javax.persistence.Entity;

@Entity
public class LocalPrivado extends Local {

	private double valorAluguel;

	public double getValorAluguel() {
		return valorAluguel;
	}

	public void setValorAluguel(double valorAluguel) {
		this.valorAluguel = valorAluguel;
	}
	
	
	
}

src/main/java/model/LocalPublico.java
package model;

import javax.persistence.Entity;

@Entity
public class LocalPublico extends Local {

	@Override
	public double getValorAluguel() {
		// TODO Auto-generated method stub
		return 0;
	}

}

src/main/java/controller/LocalBean.java
package controller;

import java.util.ArrayList;
import java.util.List;

import javax.faces.bean.ManagedBean;

import dao.LocalDao;
import model.Local;

@ManagedBean
public class LocalBean {

	private long id;

	protected List<Local> locais = new ArrayList<Local>();

	public List<Local> getListaDeLocais() {
		LocalDao daoLocal = new LocalDao();
		locais = daoLocal.listaTodos();
		return locais;
	}

	public long getId() {
		return id;
	}
	
	public void setId(long id){
		this.id = id;
	}
	
	public String remove(){
		LocalDao daoLocal = new LocalDao();
		daoLocal.remove(id);
		return "exibirLocais";
	}
	
}

src/main/java/controller/LocalPrivadoBean.java
package controller;

import java.util.Date;

import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import java.text.SimpleDateFormat;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import org.primefaces.event.SelectEvent;

import dao.LocalDao;
import model.HorarioReserva;
import model.LocalPrivado;

@ManagedBean
public class LocalPrivadoBean extends LocalBean {

	private LocalPrivado localPrivado = new LocalPrivado();
	private HorarioReserva horarioReservar = new HorarioReserva();

	public void onDateSelect(SelectEvent event) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy");
        facesContext.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Date Selected", format.format(event.getObject())));
    }

	public LocalPrivado getLocalPrivado() {
		return localPrivado;
	}

	public HorarioReserva getHorarioReservar() {
		return horarioReservar;
	}
	
	public String reservaLocalPrivado(){
		localPrivado.getHorariosAlugados().add(horarioReservar);
		LocalDao daoLocal = new LocalDao();
		daoLocal.adiciona(localPrivado);
		return "exibirLocais";
	}
	
	public String atualizaLocal(){
		LocalDao daoLocal = new LocalDao();
		daoLocal.atualiza(localPrivado);
		return "exibirLocais";
	}
	
}

src/main/java/controller/LocalPublicoBean.java
package controller;

import java.util.Date;

import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import java.text.SimpleDateFormat;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import org.primefaces.event.SelectEvent;

import dao.LocalDao;
import model.HorarioReserva;
import model.LocalPublico;

@ManagedBean
public class LocalPublicoBean extends LocalBean{

	private LocalPublico localPublico = new LocalPublico();
	private HorarioReserva horarioReservar = new HorarioReserva();

	public void onDateSelect(SelectEvent event) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy");
        facesContext.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Date Selected", format.format(event.getObject())));
    }

	public LocalPublico getLocalPublico() {
		return localPublico;
	}

	public HorarioReserva getHorarioReservar() {
		return horarioReservar;
	}
	
	public String reservaLocalPublico(){
		localPublico.getHorariosAlugados().add(horarioReservar);
		LocalDao daoLocal = new LocalDao();
		daoLocal.adiciona(localPublico);
		return "exibirLocais";
	}
	

	public String atualizaLocal(){
		LocalDao daoLocal = new LocalDao();
		daoLocal.atualiza(localPublico);
		return "exibirLocais";
	}
	
	
	
}

src/main/webapp/local/changeOrDeleteLocal.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">
<head>
<title>Empresa Patrocinadora</title>
</head>
<body>
	<h:form>
		<fieldset>
			<legend>Alterar ou Excluir empresa Patrocinadora</legend>
			<h:outputText value="ID" for="id"/>
			<h:inputText id="id" value="#{localBean.id}"/>
			<h:commandButton action="#{localBean.remove}" value="Excluir" />
			<h:commandButton action="updateLocalPublico" value="Alterar local público" />
			<h:commandButton action="updateLocalPrivado" value="Alterar local privado" />
			<h:commandButton action="empresa" value="Voltar"/>
		</fieldset>
	</h:form>
</body>
</html>

src/main/webapp/local/exibirLocais.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<h:head>
<title>Gerenciar locais</title>
</h:head>
<body>
	<f:view>
		<!-- Criando botões de comando e navegação -->
		<h:form>
			<h:commandButton action="localPrivado" value="Gerenciar Local privado" />
			<h:commandButton action="localPublico" value="Gerenciar local público" />
			<h:commandButton action="/local" value="Voltar" />
		</h:form>
		
		<!-- Fazendo aparecer todas as pessoas -->
		<p:dataTable var="local"
			value="#{localBean.listaDeLocais}">
			<p:column headerText="ID">
				<h:outputText value="#{local.id}" />
			</p:column>

			<p:column headerText="Nome">
				<h:outputText value="#{local.nome}" />
			</p:column>

		</p:dataTable>
	</f:view>
</body>
</html>

src/main/webapp/local/localPrivado.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<h:head>
	<title>Bem-vindo!</title>
</h:head>
<body>
	<f:view>
		<!-- Criando botões de comando e navegação -->
		<h:form>
			<h:commandButton action="/local" value="Voltar" />
		</h:form>
		<h:form>

			<h2>Reservar dia</h2>
			<p:calendar value="#{localPrivadoBean.horarioReservar.dia}"
				mode="inline" navigator="true" pages="2" />

			<h:panelGrid>
				<h3>Entrada</h3>
				<h:outputText value="Hora: " for="he" />
				<h:inputText id="he"
					value="#{localPrivadoBean.horarioReservar.horaEntrada}" />
				<h:outputText value="Minuto: " for="me" />
				<h:inputText id="me"
					value="#{localPrivadoBean.horarioReservar.minEntrada}" />
				<h3>Saída</h3>
				<h:outputText value="Hora: " for="hs" />
				<h:inputText id="hs"
					value="#{localPrivadoBean.horarioReservar.horaSaida}" />
				<h:outputText value="Minuto: " for="ms" />
				<h:inputText id="ms"
					value="#{localPrivadoBean.horarioReservar.minSaida}" />
			</h:panelGrid>

			<h:panelGrid>
			<h:outputText value="Nome: " for="nome" />
				<h:inputText id="nome"
					value="#{localPrivadoBean.localPrivado.nome}" />
				<h:outputText value="Bairro: " for="bairro" />
				<h:inputText id="bairro"
					value="#{localPrivadoBean.localPrivado.bairro}" />
				<h:outputText value="CEP.: " for="cep" />
				<h:inputText id="cep" value="#{localPrivadoBean.localPrivado.cep}" />
				<h:outputText value="Rua: " for="rua" />
				<h:inputText id="rua" value="#{localPrivadoBean.localPrivado.rua}" />
				<h:outputText value="Numero: " for="num" />
				<h:inputText id="num"
					value="#{localPrivadoBean.localPrivado.numero}" />

				<h:commandButton action="#{localPrivadoBean.reservaLocalPrivado}"
					value="Rervar Local" />
			</h:panelGrid>
		</h:form>



	</f:view>
</body>
</html>

src/main/webapp/local/localPublico.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<h:head>
	<title>Bem-vindo!</title>
</h:head>
<body>
	<f:view>
		<!-- Criando botões de comando e navegação -->
		<h:form>
			<h:commandButton action="/local" value="Voltar" />
		</h:form>
		<h:form>

			<h2>Reservar dia</h2>
			<p:calendar value="#{localPublicoBean.horarioReservar.dia}"
				mode="inline" navigator="true" pages="2" />

			<h:panelGrid>
				<h3>Entrada</h3>
				<h:outputText value="Hora: " for="he" />
				<h:inputText id="he" value="#{localPublicoBean.horarioReservar.horaEntrada}" />
				<h:outputText value="Minuto: " for="me" />
				<h:inputText id="me" value="#{localPublicoBean.horarioReservar.minEntrada}" />
				<h3>Saída</h3>
				<h:outputText value="Hora: " for="hs" />
				<h:inputText id="hs" value="#{localPublicoBean.horarioReservar.horaSaida}" />
				<h:outputText value="Minuto: " for="ms" />
				<h:inputText id="ms" value="#{localPublicoBean.horarioReservar.minSaida}" />
			</h:panelGrid>

			<h:panelGrid>
			<h:outputText value="Nome: " for="nome" />
				<h:inputText id="nome"
					value="#{localPublicoBean.localPublico.nome}" />
				<h:outputText value="Bairro: " for="bairro" />
				<h:inputText id="bairro"
					value="#{localPublicoBean.localPublico.bairro}" />
				<h:outputText value="CEP.: " for="cep" />
				<h:inputText id="cep" value="#{localPublicoBean.localPublico.cep}" />
				<h:outputText value="Rua: " for="rua" />
				<h:inputText id="rua" value="#{localPublicoBean.localPublico.rua}" />
				<h:outputText value="Numero: " for="num" />
				<h:inputText id="num"
					value="#{localPublicoBean.localPublico.numero}" />

				<h:commandButton action="#{localPublicoBean.reservaLocalPublico}"
					value="Rervar Local" />
			</h:panelGrid>
		</h:form>

	</f:view>
</body>
</html>

src/main/webapp/local/updateLocalPrivado.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<h:head>
	<title>Bem-vindo!</title>
</h:head>
<body>
	<f:view>
		<!-- Criando botões de comando e navegação -->
		<h:form>
			<h:commandButton action="/local" value="Voltar" />
		</h:form>
		<h:form>

			<h2>Reservar dia</h2>
			<p:calendar value="#{localPrivadoBean.horarioReservar.dia}"
				mode="inline" navigator="true" pages="2" />

			<h:panelGrid>
				<h3>Entrada</h3>
				<h:outputText value="Hora: " for="he" />
				<h:inputText id="he"
					value="#{localPrivadoBean.horarioReservar.horaEntrada}" />
				<h:outputText value="Minuto: " for="me" />
				<h:inputText id="me"
					value="#{localPrivadoBean.horarioReservar.minEntrada}" />
				<h3>Saída</h3>
				<h:outputText value="Hora: " for="hs" />
				<h:inputText id="hs"
					value="#{localPrivadoBean.horarioReservar.horaSaida}" />
				<h:outputText value="Minuto: " for="ms" />
				<h:inputText id="ms"
					value="#{localPrivadoBean.horarioReservar.minSaida}" />
			</h:panelGrid>

			<h:panelGrid>
			<h:outputText value="Nome: " for="nome" />
				<h:inputText id="nome"
					value="#{localPrivadoBean.localPrivado.nome}" />
				<h:outputText value="Bairro: " for="bairro" />
				<h:inputText id="bairro"
					value="#{localPrivadoBean.localPrivado.bairro}" />
				<h:outputText value="CEP.: " for="cep" />
				<h:inputText id="cep" value="#{localPrivadoBean.localPrivado.cep}" />
				<h:outputText value="Rua: " for="rua" />
				<h:inputText id="rua" value="#{localPrivadoBean.localPrivado.rua}" />
				<h:outputText value="Numero: " for="num" />
				<h:inputText id="num"
					value="#{localPrivadoBean.localPrivado.numero}" />

				<h:commandButton action="#{localPrivadoBean.atualizaLocal}"
					value="Atualizar Local" />
			</h:panelGrid>
		</h:form>



	</f:view>
</body>
</html>

src/main/webapp/local/updateLocalPublico.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<h:head>
	<title>Bem-vindo!</title>
</h:head>
<body>
	<f:view>
		<!-- Criando botões de comando e navegação -->
		<h:form>
			<h:commandButton action="/local" value="Voltar" />
		</h:form>
		<h:form>

			<h2>Reservar dia</h2>
			<p:calendar value="#{localPrivadoBean.horarioReservar.dia}"
				mode="inline" navigator="true" pages="2" />

			<h:panelGrid>
				<h3>Entrada</h3>
				<h:outputText value="Hora: " for="he" />
				<h:inputText id="he"
					value="#{localPrivadoBean.horarioReservar.horaEntrada}" />
				<h:outputText value="Minuto: " for="me" />
				<h:inputText id="me"
					value="#{localPrivadoBean.horarioReservar.minEntrada}" />
				<h3>Saída</h3>
				<h:outputText value="Hora: " for="hs" />
				<h:inputText id="hs"
					value="#{localPrivadoBean.horarioReservar.horaSaida}" />
				<h:outputText value="Minuto: " for="ms" />
				<h:inputText id="ms"
					value="#{localPrivadoBean.horarioReservar.minSaida}" />
			</h:panelGrid>

			<h:panelGrid>
			<h:outputText value="Nome: " for="nome" />
				<h:inputText id="nome"
					value="#{localPrivadoBean.localPrivado.nome}" />
				<h:outputText value="Bairro: " for="bairro" />
				<h:inputText id="bairro"
					value="#{localPrivadoBean.localPrivado.bairro}" />
				<h:outputText value="CEP.: " for="cep" />
				<h:inputText id="cep" value="#{localPrivadoBean.localPrivado.cep}" />
				<h:outputText value="Rua: " for="rua" />
				<h:inputText id="rua" value="#{localPrivadoBean.localPrivado.rua}" />
				<h:outputText value="Numero: " for="num" />
				<h:inputText id="num"
					value="#{localPrivadoBean.localPrivado.numero}" />

				<h:commandButton action="#{localPrivadoBean.atualizaLocal}"
					value="Atualizar Local" />
			</h:panelGrid>
		</h:form>



	</f:view>
</body>
</html>